

CR		=	$0D
LF		=	$0A
PTRSTOR =   $20 ;2bytes
PRTFLAG =   $22
LINELEN =   $23


*=$0129	; entry point for OS65A ROM MONITOR 'GO' command
	.byte $00,$00,$00,$00,$FD,>ORG,<ORG

*=$0300
ORG=*
 	SEI
	 CLD
	 JSR INITACIA
	 LDA #$00
	 STA LINELEN
TOP
     JSR CRLF
     JSR PRINT
     .BYTE 'Ready to ID HD? (Y/N)',0
	 JSR INKEY
	 JSR OUTPUT
	 JSR CRLF
	 CMP #'Y
	 BNE TOP
	 LDA $C202
	 JSR PRINTV
	 .BYTE CR,LF,'C202:',0
	 JSR CRLF
	;init DMA memory 
	LDA #$E0
	STA iloop1+2
	LDY #$0E
	LDX #$00
	LDA #$00
	EOR #$00
iloop1
	STA $E018,X
	INX 
	BNE iloop1
	INC iloop1+2
	DEY 
	BNE iloop1
	LDA #$0D
	STA $EE17

	LDA #$0F
	STA $93
	LDA #$00
	STA $A1
	LDA #$00
	STA $A2
	LDA #$00
	STA $A3
	LDA #$00
	STA $A4
	LDA #$80; $2668
	AND #$03
	STA $A0
	LDX #$A0
	CLD 
	STX $8D
	LDA $00,X

	 

	LDA #$00
	JSR L3408
	CMP #$00
	BNE HDERR
	JSR HIDENT
	JSR CRLF
	JMP EXIT
HDERR=*
	JSR PRINT 
	.BYTE CR,LF,'Disk Error $',0
	JSR PHEXA
	JSR CRLF
EXIT=*
	JMP ($FFFC)

HIDENT
	LDA $C202
	JSR PRINTV
	.BYTE CR,LF,'C202:',0
	JSR PRINT
	.BYTE CR,LF,'3400: ',0
	
	LDX #$00
HID1
	LDA L3400,X
    JSR PHEXA
    LDA #$20
    JSR OUTPUT
    INX
    CPX #$08
    BCC HID1	
	JSR PRINT
	.BYTE CR,LF,'Disk Type ',0
	LDA L3404
	CMP #$81
	BNE I2
	JSR PRINT
	.BYTE 'CD-7', 0
	RTS
I2
	CMP #$01
	BNE I3
	JSR PRINT
	.BYTE 'CD-23',0
	RTS
I3
	CMP #$10
	BNE I4
	JSR PRINT
	.BYTE 'CD-36',0
	RTS
I4  CMP #$C1
	BNE I5
	JSR PRINT
	.BYTE 'CD-28',0
	RTS
I5
	JSR PRINT
    .BYTE 'CD-74',0
	RTS

L3400 = *
L3404 =*+4
  ;.BYTE $09, $FF, $00, $00, $81, $02, $04, $08
  .BYTE $FF, $FF, $00, $00, $81, $02, $04, $08
L3408               tax
                    cpx #$01
                    lda #$03
                    bcs L343c
                    stx $80
                    lda #$00
                    bit $c280
                    sta $c207
					;PHP
					;JSR PRINT 
					JSR PRINTV
					.BYTE '  3408 W c207:',0
					;JSR PHEXA					
                    ;PLP
					lda L3404,x
                    bit $c280
                    sta $c202

					JSR PRINTV 
					.BYTE '  3408 W c202:',0
				
                    sta $8b
                    ldy #$03
                    sty $8a
L3428               ldx $80
                    lda #$08
                    clc
                    ldx #$fa
                    jsr S3478
                    beq L3477
                    bpl L3438
                    lda #$01
L3438               dec $8a
                    bpl L3428
L343c               jmp L3525
                    
                    ;a2 72 20 5a 2d d0 fb e9 01 d0 f5 
L344a               ldx $80
                    php
                    clc
L344e               lda $c202

					JSR PRINTV 
					.BYTE '  344e R c202:',0

					eor #$04
                    and #$0d
                    bcs L346a
                    beq L346f
                    bit $3452
                    beq L346c
                    nop
L3460=*+1  ;sec
                    bit $38 
                    lda #$01
                    jsr S34b3
                    bcc L3460
                    bcs L344e
L346a               beq L346f
L346c               jmp L3536
                    
L346f               plp
                    lda L3400,x
                    beq L3477
                    lda #$0e
L3477               rts
                    
S3478               sta $87
L347a               ldy #$66
L347c               lda $c202

					JSR PRINTV 
					.BYTE '  347c R c202:',0

					bcc L3483
                    eor #$ff
L3483               bcs L3486
                    nop
L3486               and $87
                    beq L344a
                    dey
                    bne L347c
                    inc $87
                    dec $87
                    jsr L3477
                    dex
                    bne L347a
                    lda #$ff
                    rts
                    
S349a               lda #$40
                    jsr S34b3
                    php
                    sec
L34a2=*+1
                    bit $18 
                    lda #$20
                    jsr S34b3
                    bcs L34a2
                    plp
                    rts
                    
S34ac               ldx #$00
                    stx $81
                    stx $94
                    rts
                    
S34b3               sta $86
                    eor #$ff
                    and $8b
                    bcc L34bd
                    ora $86
L34bd               bit $c280
                    sta $c202

					JSR PRINTV 
					.BYTE '  34bd W c202:',0

					sta $8b
                    rts
                    
                   ;                   75 03 6d 03 34 60 00 00 00 00 
                   ; 00 00 00 00 00 00 e6 8f 20 08 34 d0 21 20 eb 34 
                   ; d0 1c e6 80 a5 80 c9 01 d0 ee 60 
S34eb               jsr S37d4
L34ee               lda $c202
                    
					JSR PRINTV
					.BYTE '  34ee R c202:',0

					and #$02
                    beq L34fd
                    ldy #$01
                    clc
                    jsr S37d7
                    beq L34ee
L34fd               rts
                    
                   ;                                           c6 8f 
                   ; 10 e2 ea ea 48 a5 80 18 69 45 8d ba 2f a2 00 bd 
                   ; b4 2f 30 09 ac 91 2d 20 39 2d e8 d0 f2 a6 80 68 
                   ; 9d 00 34 d0 d2 
L3525               cmp #$0e
                    bne L3533
                    lda #$00
                    sta L3400,x
                    jsr S34eb
                    beq L3535
L3533               ora #$00
L3535               rts
                    
L3536               plp
                    nop
                    sta L3400,x
                    lda #$0d
                    rts
                    
                    ;                                          b0 42 
                    ;29 03 85 94 c0 00 e9 01 b0 38 a6 80 38 98 f5 82 
                    ;a8 a5 94 f5 84 aa d0 03 98 f0 2a b0 09 98 49 ff 
                    ;a8 8a 49 ff aa c8 98 d0 01 ca 
L356a               jsr S349a
                    dey
                    bne L356a
                    dex
                    bpl L356a
                    lda #$01
                    clc
                    ldx #$fa
                    jsr S3478
                    beq L3585
                    bpl L3581
                    lda #$02
L3581               rts
                    
                    ;a9 0f 60 
L3585               ldx $80
                    ldy $81
                    sty $82,x
                    lda $94
                    ;sta $36ff
                    sta $84,x
                    cpy #$80
                    lda #$10
                    jsr S34b3
                    lda #$00
                    rts
                    
                    ;                                    a2 02 86 8a 
                    ;a6 8d b5 04 18 20 c8 37 2a 2a 20 3e 35 d0 0f a6 
                    ;8d b5 03 2c 80 c2 8d 00 c2 20 4a 34 f0 06 c6 8a 
                    ;10 de 09 00 60 d8 86 8d b5 00 20 08 34 d0 3d a9 
                    ;06 85 8f a6 8d 20 9c 35 d0 32 a6 8d b5 02 4a 4a 
                    ;4a 4a 85 8e a9 71 8d 0f e0 20 6f 36 38 a9 80 2c 
                    ;80 c2 8d 07 c2 a0 fa ad 07 c2 10 12 a2 4c ca d0 
                    ;fd 88 d0 f3 2c 80 c2 8d 07 c2 a9 05 d0 56 20 4a 
                    ;34 d0 51 b0 01 60 ea 20 c3 36 cd 17 e0 f0 04 a9 
                    ;08 d0 39 ad 13 e0 c5 81 f0 09 20 eb 34 d0 35 a9 
                    ;09 d0 29 a6 8d ad 14 e0 55 03 29 0f f0 04 a9 0a 
                    ;d0 1a ad 15 e0 45 8e f0 04 a9 0b d0 0f 20 a1 36 
                    ;4d 18 ee d0 05 cc 19 ee f0 0a a9 0c c6 8f 30 03 
                    ;4c d3 35 a8 60 01 00 70 08 00 ee c2 ef f0 07 aa 
                    ;a5 8e 0a a8 8a 79 65 36 be 66 36 90 01 e8 08 78 
                    ;2c 80 c2 8d 03 c2 8e 04 c2 18 6d 6d 36 a8 8a 6d 
                    ;6e 36 2c 80 c2 8c 05 c2 8d 06 c2 28 60 00 00 00 
                    ;00 a9 e0 8d b1 36 a2 0e 86 8c a9 00 a8 aa 18 7d 
                    ;18 e0 90 04 c8 f0 01 18 e8 d0 f4 ee b1 36 c6 8c 
                    ;d0 ed 60 a2 06 a9 00 18 7d 10 e0 ca 10 fa 60 d8 
                    ;86 8d b5 00 20 08 34 d0 05 a6 8d 20 9c 35 d0 79 
                    ;a9 02 85 90 a2 17 a9 00 9d 1a ee e0 03 b0 02 a9 
                    ;4e 9d 00 e0 ca 10 ef a9 a1 8d 10 e0 ea ea a9 00 
                    ;8d 12 e0 a5 81 8d 13 e0 a6 8d b5 03 29 0f 8d 14 
                    ;e0 b5 02 4a 4a 4a 4a 85 8e 8d 15 e0 a5 93 8d 16 
                    ;e0 20 c3 36 8d 17 e0 20 a1 36 8d 18 ee 8c 19 ee 
                    ;a2 03 bd 69 36 95 94 ca 10 f8 a2 0f a0 1e 88 b1 
                    ;94 91 96 a9 4e 91 94 98 d0 f4 c6 95 c6 97 ca d0 
                    ;ed 20 6f 36 a9 c0 20 ef 35 d0 10 20 02 24 d0 0b 
                    ;8d fe 4d 20 db 28 20 b3 4c f0 02 09 00 60 a9 e0 
                    ;8d 82 37 20 02 24 d0 49 a0 0e a2 00 a9 00 49 00 
                    ;9d 18 e0 e8 d0 f8 ee 82 37 88 d0 f2 a9 0d 8d 17 
                    ;ee a9 0f 85 93 a9 00 85 a1 a9 00 85 a2 a9 00 85 
                    ;a3 a9 00 85 a4 ad 68 26 29 03 85 a0 a2 a0 20 cf 
                    ;36 d0 0e a2 02 b5 a2 dd dd 37 d0 06 ca 10 f6 a9 
                    ;00 60 38 20 2c 44 b0 e4 6d 02 34 85 81 a8 a9 00 
                    ;6a 4c c6 34 
S37d4               ldy #$04
                    sec
S37d7               jsr S34ac
                    jmp L356a
					    
;Print inline string and HEX value in A
PRINTV
	PHP
	INC PRTFLAG
	.BYTE $24    ;fall trough to SEI
; PRINT IN-LINE STRING
PRINT
	PHP
	SEI
    STA PRINTA
	STY PRINTY
	PLA           ;pop status
	STA PHPSTOR
	PLA           ;pop text addr
	STA PTRSTOR
	PLA          ;pop text addr hi
	STA PTRSTOR+1
PHPSTOR=*+1	
    LDA #$00
	PHA
	LDY	#1
PRINT1	
	LDA	(PTRSTOR),Y
	BEQ	PRINT2
	JSR	OUTPUT
	INY
	BNE	PRINT1
	INC PTRSTOR+1
	BNE PRINT1
PRINT2	
	TYA
	SEC
	ADC	PTRSTOR
	STA	PTRSTOR
	BCC	PRINT3
	INC	PTRSTOR+1
PRINT3
	DEC PRTFLAG
	BNE PRINT4
    LDA PRINTA   ;print hex byte & auto wrap
	JSR PHEXA
	LDA LINELEN
	CMP #64
	BCC PRINT4
	JSR CRLF
	LDA #$00
	STA LINELEN
PRINT4
	LDA #$00
	STA PRTFLAG
PRINTA=*+1
	LDA #$00
PRINTY=*+1
	LDY #$00
	PLP
	JMP	(PTRSTOR)


; PRINT HEX WORD (A,X)

PHEX	
	JSR	PHEXA
	TXA

; PRINT HEX BYTE (A)
PHEXA
	PHA
	STA PHEXAS
	LSR	A
	LSR	A
	LSR	A
	LSR	A
	JSR	PHEXA1
	PLA
PHEXA1	
	AND	#$F
	ORA	#'0'
	CMP	#'9'+1
	BMI	PHEXA2
	CLC
	ADC	#7
PHEXA2
	JSR	OUTPUT
PHEXAS=*+1
    LDA #$00
    RTS	

INITACIA
	LDA #$03
	STA $FC00
	LDA #$15	;8N1 /16
	STA $FC00
	RTS

FRACIANW  ; read from ACIA no wait	carry clear when no data
	LDA $FC00
	LSR A
	BCC FRAC1NW
	LDA $FC01
FRAC1NW
	RTS


; get char from ACIA waiting
INKEY
FRACIA   	 ;read from ACIA carry set on abort return value in A
			; read from C3
	LDA $FC00
	LSR A    
	BCC FRACIA 
	LDA $FC01
	CLC      
ACIARET
	RTS


OUTPUT=*		; output to ACIA only on C3
TOACIA 
	PHA
	CMP #$0D
	BNE TOACIA1
	LDA #$FF
	STA LINELEN
TOACIA1 
    INC LINELEN
	LDA $FC00   ;wait for TxEmpty
	LSR A     
	LSR A     
	BCC *-5   
	PLA       
	STA $FC01
	RTS  


	
ANYKEY	
	JSR	PRINT
	.BYTE	CR,LF
	.BYTE	'PRESS ANY KEY WHEN READY',CR,LF,0
	JMP	INKEY

CRLF	
	PHA
	LDA	#CR
	JSR	OUTPUT
	LDA	#LF
	JSR	OUTPUT
	PLA
	RTS

PDEC8	.BYTE $00,$00 ;2 byte
PDEC9	.BYTE $00 ;1 byte
PDEC10	.BYTE $00,$00,$00 ;3 byte 
	